import ctypes
import psutil


class GetDrives:

    def __init__(self):
        self.drives = []
        self.current_drives()

    def current_drives(self):
        partitions = psutil.disk_partitions()

        label = None
        if psutil.WINDOWS:
            for partition in partitions:
                volume_name_buffer = ctypes.create_unicode_buffer(1024)
                ctypes.windll.kernel32.GetVolumeInformationW(
                    ctypes.c_wchar_p(partition.mountpoint),
                    volume_name_buffer,
                    len(volume_name_buffer),
                    None,
                    None,
                    None,
                    None,
                    0,
                )
                label = volume_name_buffer.value
                self.drives.append(
                    {"label": label or "Unnamed", "device": partition.device}
                )
        elif psutil.LINUX:
            for partition in partitions:
                mount_point = partition.mountpoint
                device = partition.device
                self.drives.append({"label": mount_point, "device": device})
