from textual import events
from textual.app import ComposeResult
from textual.widgets import Label, Link
from textual.screen import ModalScreen
from textual.containers import Vertical


class MainMenuScreen(ModalScreen):
    """Screen with general app information"""

    def compose(self) -> ComposeResult:
        yield Vertical(
            Label(
                "heim - a terminal tool for creating directory trees from your presets",
                id="menu_label",
            ),
            Link(
                "GitHub",
                url="https://github.com/Ssoklv/",
                tooltip="Visit the official repo page for an in-depth guide",
                id="github_link",
            ),
            id="main_menu_screen",
        )

    def on_key(self, event: events.Key) -> None:
        """Closes the menu screen"""
        if event.key == "escape":
            self.app.pop_screen()
