from textual import events
from textual.app import ComposeResult
from textual.containers import Grid
from textual.widgets import Button, Label
from textual.screen import ModalScreen


class OverwriteJSONScreen(ModalScreen):
    """A dialog screen that pops up if the .json preset already exists"""

    def compose(self) -> ComposeResult:
        yield Grid(
            Label(
                "This preset already exists. Do you want to overwrite it?",
                id="question",
            ),
            Button("Yes", variant="success", id="yes_button"),
            Button("No", variant="error", id="no_button"),
            id="dialog",
        )

    def on_button_pressed(self, event: Button.Pressed) -> None:
        if event.button.id == "yes_button":
            self.dismiss(True)
        elif event.button.id == "no_button":
            self.dismiss(False)

    def on_key(self, event: events.Key) -> None:
        """Closes the screen"""
        if event.key == "escape":
            self.app.pop_screen()
